#extension GL_OES_EGL_image_external : require
precision mediump int;
precision mediump float;
uniform samplerExternalOES sTexture;
varying vec2 vTextureCoord;

float _hable_3_0(float x) {
return ((x * (0.150000*x + 0.050000)+0.004000)/(x * (0.150000*x + 0.500000) + 0.060000))- 0.066667;
}

vec4 _main_4_0(vec4 color) {
    // pl_shader_color_map
    vec3 _src_luma_0_0 = vec3(0.262698,0.678009,0.059293);
    vec3 _dst_luma_1_0 = vec3(0.212637,0.715183,0.072180);
    mat3 _cms_matrix_2_0 = mat3(1.660497,-0.124547,-0.018154,-0.587657,1.132895,-0.100597,-0.072840,-0.008348,1.118751);

    // pl_shader_linearize
    color.rgb = max(color.rgb, 0.0);
    color.rgb = mix(vec3(4.0) * color.rgb * color.rgb,
    exp((color.rgb - vec3(0.559911)) * vec3(1.0/0.178833)) + vec3(0.284669), vec3(lessThan(vec3(0.5), color.rgb)));
    // pl_shader_ootf
    color.rgb = max(color.rgb, 0.0);
    color.rgb *= vec3(0.506970 * pow(dot(_src_luma_0_0, color.rgb), 0.2));
    color.rgb = _cms_matrix_2_0 * color.rgb;
    // pl_shader_tone_map
    float sig = max(max(color.r, color.g), color.b);
    float sig_peak = 12.000000;
    float sig_avg = 0.250000;
    float luma = dot(_dst_luma_1_0, color.rgb);
    float coeff = max(sig - 0.18, 1e-6) / max(sig, 1e-6);
    coeff = pow(coeff, 20.000000);
    color.rgb = mix(color.rgb, vec3(luma), coeff);
    sig = mix(sig, luma, coeff);
    float sig_orig = sig;
    float slope = min(1.0, 0.250000 / sig_avg);
    sig *= slope;
    sig_peak *= slope;
    sig = _hable_3_0(sig) / _hable_3_0(sig_peak);
    sig = min(sig, 1.0);
    color.rgb *= sig / sig_orig;
    // pl_shader_delinearize
    color.rgb = max(color.rgb, 0.0);
    color.rgb = pow(color.rgb, vec3(1.0/2.2));
    return color;
}

void main()
{
    vec4 sColor = texture2D(sTexture, vTextureCoord);
    gl_FragColor =  _main_4_0(sColor);
}